-#!/bin/bash
+#!/usr/bin/env bash
# SPDX-License-Identifier: MIT
-set -x
-set -e
+set -o errexit
+set -o nounset
+set -o pipefail
+set -o xtrace
+
+cd "$(dirname "$0")"
unset LC_CTYPE
unset LANG
export ARCH=arm64
export CROSS_COMPILE=aarch64-linux-gnu-
export DEBOOTSTRAP=qemu-debootstrap
+ sudo apt install -y libc6-dev-arm64-cross
fi
}
{
(
handle_crosscompile
- test -d linux || git clone --depth 1 https://github.com/AsahiLinux/linux -b asahi
+ test -d linux || git clone https://github.com/AsahiLinux/linux
cd linux
- git fetch
- git reset --hard origin/asahi; git clean -f -x -d &> /dev/null
- curl -s https://tg.st/u/0001-4k-iommu-patch.patch | git am -
- curl -s https://tg.st/u/DXyl.patch | git am -
- curl -s https://tg.st/u/0001-apple-mca-correct-prinkts.patch | git am -
- curl -s https://tg.st/u/0001-Hookup-backlight-for-MacBook-Pro-13-inch-M1-2020-J29.patch | git am -
- curl -s https://tg.st/u/XKVZ.patch | git am -
- curl -s https://tg.st/u/config-2022-02-19 > .config
+ git fetch -a -t
+ git reset --hard asahi-6.0-rc6-1; git clean -f -x -d &> /dev/null
+ curl -s https://tg.st/u/40c9642c7569c52189f84621316fc9149979ee65.patch | git am -
+ cat ../../config > .config
make olddefconfig
- make -j `nproc` V=0 bindeb-pkg
+ make -j `nproc` V=0 bindeb-pkg > /dev/null
)
}
build_m1n1()
{
(
- test -d m1n1 || git clone --recursive https://github.com/AsahiLinux/m1n1.git
+ test -d m1n1 || git clone --recursive https://github.com/AsahiLinux/m1n1
cd m1n1
- git fetch
- git reset --hard origin/main; git clean -f -x -d &> /dev/null
+ git fetch -a -t
+ # https://github.com/AsahiLinux/PKGBUILDs/blob/main/m1n1/PKGBUILD
+ git reset --hard v1.1.4; git clean -f -x -d &> /dev/null
make -j `nproc`
)
}
{
(
handle_crosscompile
- test -d u-boot || git clone --depth 1 https://github.com/jannau/u-boot -b x2r10g10b10
+ test -d u-boot || git clone https://github.com/AsahiLinux/u-boot
cd u-boot
- git fetch
- git reset --hard origin/x2r10g10b10; git clean -f -x -d &> /dev/null
- curl -s https://tg.st/u/v2-console-usb-kbd-Limit-poll-frequency-to-improve-performance.diff | patch -p1
+ git fetch -a -t
+ # For tag, see https://github.com/AsahiLinux/PKGBUILDs/blob/main/uboot-asahi/PKGBUILD
+ git reset --hard asahi-v2022.07-3; git clean -f -x -d &> /dev/null
+ git revert --no-edit 4d2b02faf69eaddd0f73758ab26c456071bd2017
+ curl -s https://tg.st/u/0001-usb_setup_descriptor-Add-1ms-delay-in-order-to-unbre.patch | git am -
+
make apple_m1_defconfig
make -j `nproc`
)
- cat m1n1/build/m1n1.bin `find linux/arch/arm64/boot/dts/apple/ -name \*.dtb` u-boot/u-boot-nodtb.bin > u-boot.bin
- cat m1n1/build/m1n1.macho `find linux/arch/arm64/boot/dts/apple/ -name \*.dtb` u-boot/u-boot-nodtb.bin > u-boot.macho
+ cat m1n1/build/m1n1.bin `find linux/arch/arm64/boot/dts/apple/ -name \*.dtb` <(gzip -c u-boot/u-boot-nodtb.bin) > u-boot.bin
+ cat m1n1/build/m1n1.macho `find linux/arch/arm64/boot/dts/apple/ -name \*.dtb` <(gzip -c u-boot/u-boot-nodtb.bin) > u-boot.macho
+ cp u-boot.bin 4k.bin
+ cp u-boot.bin 2k.bin
+ echo 'display=2560x1440' >> 2k.bin
+ echo 'display=wait,3840x2160' >> 4k.bin
+
}
build_rootfs()
handle_crosscompile
sudo rm -rf testing
mkdir -p cache
- sudo eatmydata ${DEBOOTSTRAP} --cache-dir=`pwd`/cache --arch=arm64 --include initramfs-tools,wpasupplicant,tcpdump,vim,tmux,vlan,ntpdate,parted,curl,wget,grub-efi-arm64,mtr-tiny,dbus,ca-certificates,sudo,openssh-client,mtools testing testing http://ftp.fau.de/debian
+ sudo eatmydata ${DEBOOTSTRAP} --cache-dir=`pwd`/cache --arch=arm64 --include initramfs-tools,pciutils,wpasupplicant,tcpdump,vim,tmux,vlan,ntpdate,parted,curl,wget,grub-efi-arm64,mtr-tiny,dbus,ca-certificates,sudo,openssh-client,mtools,gdisk,cryptsetup testing testing http://deb.debian.org/debian
export KERNEL=`ls -1rt linux-image*.deb | grep -v dbg | tail -1`
sudo mkdir -p boot/efi
- sudo bash -c 'echo live > etc/hostname'
+ sudo bash -c 'echo debian > etc/hostname'
sudo bash -c 'echo > etc/motd'
sudo chroot . dpkg -i ${KERNEL}
sudo rm ${KERNEL}
- sudo bash -c 'apt-get clean'
+ sudo bash -c 'chroot . apt-get clean'
)
}
{
(
rm -f media
- dd if=/dev/zero of=media bs=1 count=0 seek=1G
+ dd if=/dev/zero of=media bs=1 count=0 seek=2G
mkdir -p mnt
- mkfs.ext4 -O ^metadata_csum media
+ mkfs.ext4 media
tune2fs -O extents,uninit_bg,dir_index -m 0 -c 0 -i 0 media
sudo mount -o loop media mnt
sudo cp -a testing/* mnt/
export INITRD=`ls -1 testing/boot/ | grep initrd`
export VMLINUZ=`ls -1 testing/boot/ | grep vmlinuz`
- export UUID=`blkid media | awk -F\" '{print $2}'`
+ export UUID=`blkid -s UUID -o value media`
cat > EFI/debian/grub.cfg <<EOF
search.fs_uuid ${UUID} root
linux (\$root)/boot/${VMLINUZ} root=UUID=${UUID} rw
)
}
+build_asahi_installer_image()
+{
+(
+ rm -rf aii
+ mkdir -p aii/esp/m1n1
+ cp -a EFI aii/esp/
+ cp u-boot.bin aii/esp/m1n1/boot.bin
+ ln media aii/media
+ cd aii
+ zip -r9 ../debian-base.zip esp media
+)
+}
+
build_di_stick()
{
rm -rf di-stick
{
export KERNEL=`ls -1rt linux-image*.deb | grep -v dbg | tail -1`
cp ${KERNEL} k.deb
- sudo cp m1-d-i.tar m1.tgz efi.tgz asahi-debian-live.tar u-boot.bin u-boot.macho di-stick/vmlinuz k.deb m1n1/build/m1n1.bin m1n1/build/m1n1.macho testing/usr/lib/grub/arm64-efi/monolithic/grubaa64.efi /u/
+ sudo cp m1-d-i.tar m1.tgz efi.tgz asahi-debian-live.tar u-boot.bin u-boot.macho 2k.bin 4k.bin k.deb m1n1/build/m1n1.bin m1n1/build/m1n1.macho testing/usr/lib/grub/arm64-efi/monolithic/grubaa64.efi debian-base.zip /u/
}
mkdir -p build
cd build
-sudo apt-get install -y build-essential bash git locales gcc-aarch64-linux-gnu libc6-dev-arm64-cross device-tree-compiler imagemagick ccache eatmydata debootstrap pigz libncurses-dev qemu-user-static binfmt-support rsync git flex bison bc kmod cpio libncurses5-dev libelf-dev:native libssl-dev
+sudo apt-get install -y build-essential bash git locales gcc-aarch64-linux-gnu libc6-dev device-tree-compiler imagemagick ccache eatmydata debootstrap pigz libncurses-dev qemu-user-static binfmt-support rsync git flex bison bc kmod cpio libncurses5-dev libelf-dev:native libssl-dev dwarves
build_linux
build_m1n1
build_uboot
+
+exit
+
build_rootfs
-build_live_stick
-build_di_stick
+#build_di_stick
build_dd
build_efi
+build_asahi_installer_image
+build_live_stick
publish_artefacts
+
+echo 'Reminder: On the next release publish __all__ kernel packages'